import { ChainName, TokenId, TxHash, Platform, WormholeMessageId, SignedTx, AutomaticTokenBridge, TokenBridge, CircleBridge, AutomaticCircleBridge, ChainsConfig, NativeAddress, WormholeCore } from '@wormhole-foundation/connect-sdk';
import { ethers } from 'ethers';
import { EvmContracts } from './contracts';
import { EvmChain } from './chain';
/**
 * @category EVM
 */
export declare class EvmPlatform implements Platform<'Evm'> {
    static _platform: 'Evm';
    readonly platform: "Evm";
    readonly conf: ChainsConfig;
    readonly contracts: EvmContracts;
    constructor(conf: ChainsConfig);
    getRpc(chain: ChainName): ethers.Provider;
    getChain(chain: ChainName): EvmChain;
    getWormholeCore(rpc: ethers.Provider): Promise<WormholeCore<'Evm'>>;
    getTokenBridge(rpc: ethers.Provider): Promise<TokenBridge<'Evm'>>;
    getAutomaticTokenBridge(rpc: ethers.Provider): Promise<AutomaticTokenBridge<'Evm'>>;
    getCircleBridge(rpc: ethers.Provider): Promise<CircleBridge<'Evm'>>;
    getAutomaticCircleBridge(rpc: ethers.Provider): Promise<AutomaticCircleBridge<'Evm'>>;
    getDecimals(chain: ChainName, rpc: ethers.Provider, token: TokenId | 'native'): Promise<bigint>;
    getBalance(chain: ChainName, rpc: ethers.Provider, walletAddr: string, tokenId: TokenId | 'native'): Promise<bigint | null>;
    sendWait(rpc: ethers.Provider, stxns: SignedTx[]): Promise<TxHash[]>;
    parseAddress(chain: ChainName, address: string): NativeAddress<'Evm'>;
    parseTransaction(chain: ChainName, rpc: ethers.Provider, txid: TxHash): Promise<WormholeMessageId[]>;
}
//# sourceMappingURL=platform.d.ts.map